package net.sweevo.jinks.network;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.network.codec.ByteBufCodecs;
import net.minecraft.network.codec.StreamCodec;
import net.minecraft.network.protocol.common.custom.CustomPacketPayload;
import net.minecraft.resources.ResourceLocation;
import net.neoforged.neoforge.network.handling.IPayloadContext;
import net.sweevo.jinks.ExtBackup;
import net.sweevo.jinks.client.ClientEventHandler;

import javax.annotation.Nonnull;

public record Pause(boolean pause) implements CustomPacketPayload {

    public static final ResourceLocation ID = ResourceLocation.fromNamespaceAndPath(ExtBackup.MODID, "pause");
    public static final CustomPacketPayload.Type<Pause> TYPE = new Type<>(ID);

    public static final StreamCodec<FriendlyByteBuf, Pause> CODEC = StreamCodec.composite(
            ByteBufCodecs.BOOL, Pause::pause, Pause::new
    );

    @Nonnull
    @Override
    public Type<? extends CustomPacketPayload> type() {
        return Pause.TYPE;
    }

    public void handle(IPayloadContext context) {
        ClientEventHandler.setPaused(this.pause);
    }
}
